<?php
/***************************************************************************\
*
*	orgaMAX Warenwirtschaftssystem
*	http://www.orgamax.de
*
*	Copyright (c) 2010 deltra Software GmbH
*	http://www.deltra.de
*
*  	Dieses Script ist Teil der orgaMAX Shopanbindung - Version 3.0.00
*
\***************************************************************************/

$GLOBALS['VERSION_SCF'] = "3.0.11";

function starten()
{
	// dummy
}

/** Elemente in DOM einfgen  */
function Add_NewDocElement($root, $parent, $name, $value) {
    $parent->appendChild($root->createElement($name))->appendChild($root->createTextNode($value));
}

/** Start-Funktion Datenbertragung Magento -> orgaMax */
function daten_holen() {
	
	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet	
	// datakind == 3 => Daten werden als XMLDoc durchgereicht
	
	$GLOBALS['datakind'] = "3";
	
    try {

        /** Magento Framework laden*/
        //
        //  !!! Datei-Referenz bitte anpassen !!!
        //
        require_once(REF_MAGE);
        Mage::app();

        /** XML-Dokument erzeugen */
        $dom = new DomDocument('1.0');
        $dom->xmlStandalone = true;
        $dom->encoding="utf-8";

        /** orgaMax oberstes Knotenelement */
        $domOrders = $dom->appendChild($dom->createElement('OrderNotification'));

        /** Erforderliche Magento Modelle heranziehen */
        $ordersMag = Mage::getModel('sales/mysql4_order_collection');
        $ordersInfo = Mage::getModel('sales/order_item')->getCollection();

        /**
         * Magento Basis-Stati Verkaufauftr�ge (sales_ order_states)
         * pending
         * processing
         * complete
         * closed
         * canceled
         * holded
         */
        $status = 'pending';
        switch($GLOBALS["DEFAULT_ORDERS_STATUS"])
        {
        	case 0:
        		$status = 'pending';
        		break;
        	case 1:
        		$status = 'processing';
        		break;
        	case 2:
        		$status = 'complete';
        		break;
        	case 3:
        		$status = 'closed';
        		break;
        	case 4:
        		$status = 'canceled';
        		break;
        	case 5:
        		$status = 'holded';
        		break;
        }
        /** orgaMax Importfilter f�r Verkaufsauftrge */
        $ordersMag->addFieldToFilter('status',Array('eq'=>$status));

        /** Alle gefilterten Verkaufsauftrge holen */
        $colOrderIDs = $ordersMag->getAllIds();
        
        /** Hauptschleife */
        foreach($colOrderIDs as $loopOrderID) {
            $tmpOrder = Mage::getModel('sales/order');
            $tmpOrder->load($loopOrderID);
			
            /** orgaMax Knoten Bestellvorgang */
            $domOrder = $domOrders->appendChild($dom->createElement('Bestellvorgang'));
            $orderData = $tmpOrder->getData();
			
            $streetBA=$tmpOrder->getBillingAddress()->getStreet();
            $streetSA=$tmpOrder->getShippingAddress()->getStreet();
            
            $customer = Mage::getModel('customer/customer')->load($orderData['customer_id'])->getData();
     
            //Alle Bezahlinformationen
            $paymentInformation = $tmpOrder->getPayment()->toArray();
            
            /** orgamax Bestellvorgang  Daten */
            Add_NewDocElement($dom, $domOrder, 'BestellnummerShop', $orderData['increment_id']);     //$tmpOrder->getData('increment_id'));
            Add_NewDocElement($dom, $domOrder, 'Bestelldatum', strftime("%d-%m-%Y %H:%M%p",strtotime($orderData['created_at'])));
            Add_NewDocElement($dom, $domOrder, 'Wunschlieferdatum', '');                        //In Magento nicht vorhanden.
            //2011-04-19,HM, Transportmethode
            //     ggf. Transportunternehmen 'shipping_description'
            Add_NewDocElement($dom, $domOrder, 'Lieferart', $orderData['shipping_method']);
            //2011-04-19,HM, Zahlungsmethode/Zahlungsart
            Add_NewDocElement($dom, $domOrder, 'Zahlungsart', $paymentInformation["method"]);
            //2011-04-19,HM, Zusatzfelder befüllt
            Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung1', $orderData['order_currency_code']);
            Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung2', $orderData['base_grand_total']);
            Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung3', $orderData['base_tax_amount']);
            Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung4', $orderData['base_shipping_amount']);
            Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung5', $orderData['base_shipping_tax_amount']);
            Add_NewDocElement($dom, $domOrder, 'AnmerkungenBestellung', $orderData['customer_note']);

            /** orgaMax Knoten Kundendaten */
            $domCustomerData = $domOrder->appendChild($dom->createElement('Kundendaten'));
            /** orgaMax Knoten Kunde */
            $domCustormer = $domCustomerData->appendChild($dom->createElement('Kunde'));
            /** orgaMax Knoten Kunde Daten*/
   
            Add_NewDocElement($dom, $domCustormer, 'Kundennummer', ''); // Magento bietet nicht die Mglichkeit eine eigene Kundennummer zu hinterlegen
            Add_NewDocElement($dom, $domCustormer, 'KundennummerWebshop', $orderData['customer_id']);
            Add_NewDocElement($dom, $domCustormer, 'Firmenname', $tmpOrder->getBillingAddress()->getCompany());

            Add_NewDocElement($dom, $domCustormer, 'Firmenzusatzname', '');
            Add_NewDocElement($dom, $domCustormer, 'PersonAnrede', $orderData['customer_prefix']);
            //2011-04-19,HM,
            Add_NewDocElement($dom, $domCustormer, 'PersonGeschlecht', $orderData['customer_gender']);
            Add_NewDocElement($dom, $domCustormer, 'PersonTitel', '');
            Add_NewDocElement($dom, $domCustormer, 'PersonNachname', $orderData['customer_lastname']);
            Add_NewDocElement($dom, $domCustormer, 'PersonVorname', $orderData['customer_firstname']);
            Add_NewDocElement($dom, $domCustormer, 'Strasse', $tmpOrder->getBillingAddress()->getStreet());
            Add_NewDocElement($dom, $domCustormer, 'Postleitzahl', $tmpOrder->getBillingAddress()->getPostcode());
            Add_NewDocElement($dom, $domCustormer, 'Ort', $tmpOrder->getBillingAddress()->getCity());
            Add_NewDocElement($dom, $domCustormer, 'Laendercode', $tmpOrder->getBillingAddress()->getData('country_id'));
            Add_NewDocElement($dom, $domCustormer, 'Land', $tmpOrder->getBillingAddress()->getRegion());
            Add_NewDocElement($dom, $domCustormer, 'Email', $orderData['customer_email']);
            Add_NewDocElement($dom, $domCustormer, 'Telefon', $tmpOrder->getBillingAddress()->getData('telephone'));
            Add_NewDocElement($dom, $domCustormer, 'Fax', $tmpOrder->getBillingAddress()->getData('fax'));
            Add_NewDocElement($dom, $domCustormer, 'Umsatzsteueridentnummer', $customer['taxvat']);
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde1', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde2', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde3', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde4', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde5', '');

            /** orgaMax Knoten Kontodaten */
            $domAccountData = $domCustomerData->appendChild($dom->createElement('Kontodaten'));
            /** orgaMax Kontodaten */
            
            $bankData = $tmpOrder->getPayment()->getMethodInstance();
            Add_NewDocElement($dom, $domAccountData, 'BankkontoInhaber', $bankData->getAccountName());
            Add_NewDocElement($dom, $domAccountData, 'Bankkontonummer', $bankData->getAccountNumber());
            Add_NewDocElement($dom, $domAccountData, 'BankkontoBLZ', $bankData->getAccountBLZ());
            Add_NewDocElement($dom, $domAccountData, 'BankkontoBankName', $bankData->getAccountBankname()); 
		
            /** orgaMax Knoten AbweichendLieferung */
            $domDivergentShipment = $domCustomerData->appendChild($dom->createElement('AbweichendLieferung'));
            /** orgaMax AbweichendLieferung Daten*/
            
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFirmenname', $tmpOrder->getShippingAddress()->getCompany());
            
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFirmenzusatz', '');
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersAnrede', $tmpOrder->getShippingAddress()->getPrefix());
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersGeschl', '');
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersTitel', ''); 
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersNachname', $tmpOrder->getShippingAddress()->getLastname());
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersVorname', $tmpOrder->getShippingAddress()->getFirstname());
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungStrasse', $streetSA[0]);
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPostleitzahl', $tmpOrder->getShippingAddress()->getPostcode());
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungOrt', $tmpOrder->getShippingAddress()->getCity());
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungLaendercode', $tmpOrder->getShippingAddress()->getData('country_id'));
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungLand', $tmpOrder->getShippingAddress()->getRegion());
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungEmail', ''); 
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungTelefon', $tmpOrder->getShippingAddress()->getData('telephone'));
            Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFax', $tmpOrder->getShippingAddress()->getData('fax'));

            /** orgaMax Knoten AbweichendRechnung */
            $domDivergentInvoice = $domCustomerData->appendChild($dom->createElement('AbweichendRechnung'));
            /** orgaMax AbweichendRechnung Daten*/
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungFirmenname', $tmpOrder->getBillingAddress()->getCompany());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungFirmenzusatz', '');
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersAnrede',$tmpOrder->getBillingAddress()->getPrefix());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersGeschl', ''); 
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersTitel', ''); 
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersNachname', $tmpOrder->getBillingAddress()->getLastname());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersVorname', $tmpOrder->getBillingAddress()->getFirstname());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungStrasse', $streetBA[0]);
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPostleitzahl', $tmpOrder->getBillingAddress()->getPostcode());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungOrt', $tmpOrder->getBillingAddress()->getCity());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungLaendercode', $tmpOrder->getBillingAddress()->getData('country_id'));
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungLand', $tmpOrder->getBillingAddress()->getRegion());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungEmail', '');
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungTelefon', $tmpOrder->getBillingAddress()->getData('telefon'));
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungFax', $tmpOrder->getBillingAddress()->getData('fax'));

            /** orgaMax Knoten Frachtkosten */
            $domFreightCharges = $domCustomerData->appendChild($dom->createElement('Frachtkosten'));
            /** orgaMax Frachtkosten Daten*/
  
            //2011-04-19,HM, Frachtkosten-Nettobetrag
            Add_NewDocElement($dom, $domFreightCharges, 'FrachtkostenNetto', $orderData['shipping_amount']);
            //2011-04-19,HM, Frachtkosten-Bruttobetrag
            Add_NewDocElement($dom, $domFreightCharges, 'FrachtkostenBrutto',$orderData['shipping_amount'] + $orderData['shipping_tax_amount']);
            Add_NewDocElement($dom, $domFreightCharges, 'FrachtkostenMwStProzent', '');

            /** orgaMax Knoten Zuschlagkosten */
            $domaAditionalCosts = $domOrder->appendChild($dom->createElement('Zuschlagkosten'));
            /** orgaMax Zuschlagkosten Daten*/
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenNetto1', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenBrutto1', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenMwStProzent1', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenNetto2', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenBrutto2', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenMwStProzent2', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenNetto3', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenBrutto3', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenMwStProzent3', '');

            /* orgaMax Knoten Bestellartikel */
            foreach ($tmpOrder->getItemsCollection() as $item) {
                $domOrderItem = $domOrder->appendChild($dom->createElement('BestellArtikel'));
                $itemData = $item->getOrigData();
                 /* orgaMax Bestellartikel Daten*/
                Add_NewDocElement($dom, $domOrderItem,'Positionsnummer',''); //Magento unterhlt keine Positionsnummer
                Add_NewDocElement($dom, $domOrderItem,'Artikelnummer', ($GLOBALS['artno_handling'] == 1) ? $itemData['sku'] : '');
                Add_NewDocElement($dom, $domOrderItem,'ArtikelnummerShop',$itemData['sku']);
                Add_NewDocElement($dom, $domOrderItem,'Menge', $item->getQtyOrdered());
                Add_NewDocElement($dom,$domOrderItem, 'Gewicht',$itemData['weight']);
                Add_NewDocElement($dom, $domOrderItem,'abweichenderEinzelpreisNetto', $item->getPrice());
                //2011-04-18,HM, EinzelpreisBrutto);
                Add_NewDocElement($dom, $domOrderItem,'abweichenderEinzelpreisBrutto', $item->getPriceInclTax());
                Add_NewDocElement($dom, $domOrderItem,'abweichendeMwStProzent', $itemData['tax_percent']);
                //2011-04-19,HM, Artikelname (-bezeichnung) in abweichenden Artikeltext eingefgt.
                Add_NewDocElement($dom, $domOrderItem,'abweichenderArtikeltext', $item->getName());
                // 2011-04-18,HM, RabattBetrag erh�lt man ber $item->getDiscountAmount()
                Add_NewDocElement($dom, $domOrderItem,'RabattProzent', $itemData['discount_percent']);
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition1','');
                //2011-04-19,HM, Artikelgewicht
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition2','');
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition3','');
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition4','');
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition5','');

            }
            /** Status des herangezogenen Verkaufsauftrag wechseln */
            //
            // Methode 1
            //

            $state = $GLOBALS["aendern_zu"];
            $status = $GLOBALS["aendern_zu"];
            $comment = 'Der Status des Verkaufsauftrag wurde von orgaMAX gendert.';
            $isCustomerNotified = false;
            $tmpOrder->setState($state, $status, $comment, $isCustomerNotified);

            $tmpOrder->save();

        }

        $dom->formatOutput = true;
        $GLOBALS['XMLDoc'] = $dom->saveXML();
        return $GLOBALS['datakind'];

    } catch (Exception $e) {

        $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
        '<orgamax_phperror>'."\n".
        '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
        '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
        '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
        '<line>'.utf8_encode(__LINE__).'</line>'."\n".
        '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
        '</orgamax_phperror>';
        die ($catchExeption);

    }
}

function artikeldaten_shop_zu_orgamax()
{
	$GLOBALS['datakind'] = '3';
	try {
		require_once(REF_MAGE);
	    
		Mage::app();
		
		/** XML-Dokument erzeugen */
	    $dom = new DomDocument('1.0');
	    $dom->xmlStandalone = true;
	    $dom->encoding="utf-8";
		 /** orgaMax oberstes Knotenelement */
        $domProducts = $dom->appendChild($dom->createElement('Artikelimport'));
		
        //Alle Produkte auslesen
        $model = Mage::getModel('catalog/product');
	
        $products = $model->getCollection();
        
		// Produkte aus dem Magentoshop auslesen
		foreach($products as $product)
		{
			$artikelRow = $domProducts->appendChild($dom->createElement('row'));
			$model->load($product->getId());
				
			
			//nimmt nur die erste Kategorie von dem Produkt. Mehr als 1 ist nicht mglich
			$categoryName = '';
			foreach($product->getCategoryIds() as $categoryID)
			{
				$category = Mage::getModel('catalog/category')->load($categoryID);
				
				$categoryName = $category->getName();
				break;
			}
			//Holt den MwSTCode zurm Product
			$rateModel = Mage::getSingleton('tax/calculation_rate')->load($model->getTaxClassId());
			if($rateModel->getRate() < 1)
			{
				$netPrice = $model->getPrice();
			}
			else 
			{
				$netPrice = ($model->getPrice() * 100) / $rateModel->getRate();
			}
			
			Add_NewDocElement($dom, $artikelRow, 'Artikelnummer', ($GLOBALS["artno_handling"] == 1) ? $model->getId() : '');
			Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $model->getId());
			Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $model->getName());
			Add_NewDocElement($dom, $artikelRow, 'MwStCode', $rateModel->getRate());
			Add_NewDocElement($dom, $artikelRow, 'Einheit', $model->getUnitMeasure());
			Add_NewDocElement($dom, $artikelRow, 'Artikelkategorie', $categoryName);
			Add_NewDocElement($dom, $artikelRow, 'Gewicht', $model->getWeight());
			Add_NewDocElement($dom, $artikelRow, 'Volumen', $model->getVolume());
			Add_NewDocElement($dom, $artikelRow, 'Anmerkungen',$model->getDescription());
			Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisNetto', $netPrice);
			Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisBrutto',$model->getPrice());
			Add_NewDocElement($dom, $artikelRow, 'Einkaufspreis', ($model->getCost() !== NULL) ? $model->getCost() : '');
			Add_NewDocElement($dom, $artikelRow, 'Artikelbild',$model->getImageUrl());
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld1', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld2','');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld3', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld4','');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld5', '');
		}
		$dom->formatOutput = true;
        $GLOBALS['XMLDoc'] = $dom->saveXML();
        return $GLOBALS['datakind'];
	} 
	catch (Exception $e) {
		 $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
        '<orgamax_phperror>'."\n".
        '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
        '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
        '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
        '<line>'.utf8_encode(__LINE__).'</line>'."\n".
        '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
        '</orgamax_phperror>';
        die ($catchExeption);
	}
}

function artRow_ueberpruefen($artRow)
{
	return $artRow;
}

function ende()
{
	// dummy
}
//*********************************************************
// orgaMax Import-Schnittstelle Magento Ende
//*********************************************************
?>